/**
 * @file
 * AJAX pager.
 */

(function($) {
  Drupal.behaviors.entity_lister = {
    attach: function(context, settings) {

      var entity_lister = {

        pager: function(vals, page, id) {

          if (!page) {
            vals.page = '0';
          }
          else {
            vals.page = page;
          }

          $.post('/?q=' + pager_path, vals, function(data) {
            $('#' + id).html(data);
            Drupal.attachBehaviors('#' + id);
          });

          if ('1' == vals.config.pager_st) {
            // Scroll up.
            offset = $('#' + id).offset();
            st = offset.top - vals.config.pager_st_offset;
            duration = parseInt(vals.config.pager_st_time);
            $("html, body").animate({scrollTop: st}, {duration: duration});
          }

          return false;
        },

        parseQS: function(varName, qs) {
          var qStr = qs + '&';
          var regex = new RegExp('.*?[&\\?]' + varName + '=(.*?)&.*');
          val = qStr.replace(regex, "$1");
          return val == qStr ? false : val;
        },

        pagerListen: function(vals, id) {
          $('#' + id + ' .pager a').once().click(function(e){
            e.preventDefault();
            href = $(this).attr('href');
            arr = href.split('?');
            qs = '?' + arr[1];
            page = entity_lister.parseQS('page', qs);
            entity_lister.pager(vals, page, id);
          });
        }

      }

      var delta;

      for (delta in settings.entity_lister) {

        var vals = new Object();
        vals.delta = delta;

        var config = vals.config = settings.entity_lister[delta].config;
        var id_prefix = vals.id_prefix = settings.entity_lister[delta].id_prefix;
        var list_class = vals.list_class = settings.entity_lister[delta].list_class;
        var pager_path = vals.pager_path = settings.entity_lister[delta].pager_path;
        var extra = vals.extra = settings.entity_lister[delta].extra;
        var id = id_prefix + '-' + delta;

        entity_lister.pagerListen(vals, id);

      }

    }
  };

})(jQuery);
